/**
	Showcase v1.0
	@uses: MooTools 1.3, 1.4
	@author: Constantin Boiangiu ( constantin.b[at]gmail.com )
	@copyright: Youjoomla.com
**/
var Showcase = new Class({
	Implements: [Options],
	options:{
		overallContainer: null,
		elementScrolled: null,
		thumbsContainer: null,		
		itemsVisible:5,
		elemsSlide: null,
		itemsSelector: null,
		itemWidth: null,
		duration: 800,
		direction: 1,
		autoSlide: false,
		navigationContainer: null,
		navigationElem: null
	},
	initialize: function(options) {
		this.setOptions(options||null);
		
		
		this.elements = $(this.options.thumbsContainer).getElements(this.options.itemsSelector);
		this.totalElements = this.elements.length;
		if( this.totalElements <= this.options.itemsVisible ) return;
		this.elementWidth = this.options.itemWidth || this.elements[0].getSize().x;
		this.currentElement = 0;
		this.direction = this.options.direction;
		this.autoSlideTotal = this.options.autoSlide + this.options.duration;
		if( this.options.elemsSlide == 1 ) this.options.elemsSlide = null;
		this.begin();
		this.highlightNavs();
	},
		
	begin: function(){	
		this.setContainersSize();
		
		this.myFx = new Fx.Morph(this.options.thumbsContainer, { 
			link: 'cancel', 
			transition: Fx.Transitions.linear,
			duration: this.options.duration
		});		
				
		if( this.options.autoSlide )
			this.startAutoSlide();
		
		
		this.navs = $(this.options.navigationContainer).getElements(this.options.navigationElem);
		this.navs.each(function(el, i){
			el.addEvent('click', function(event){
				event.stop();
				if(this.endingElem) return;
				/* clear autoslide if set and restart it */
				if(this.options.autoSlide){
					clearInterval(this.autoSlide);						
					this.autoSlide = this.startIt.periodical(this.autoSlideTotal, this);
				}
				
				if(i==this.currentElement) return;
				var direction = i < this.currentElement ? -1:1; 
				this.direction = direction;
				this.options.elemsSlide = (i-this.currentElement)*direction;
				this.slide(direction);			
				
			}.bind(this));
		}.bind(this));
		
	},
	
	setContainersSize: function(){
		$(this.options.overallContainer).set({
			styles:{
				'width': this.options.itemsVisible * this.elementWidth
			}
		});
		$(this.options.elementScrolled).set({
			styles:{
				'width': this.options.itemsVisible * this.elementWidth
			}
		});
		$(this.options.thumbsContainer).set({
			styles:{
				'width': this.totalElements * (this.elementWidth + 10)	
			}
		});
	},
	
	slide: function( direction ){
		
		if(this.started) return;
		this.direction = direction;
		var currentIndex = this.currentIndex();
		
		if( this.options.elemsSlide && this.options.elemsSlide>=1 && this.endingElem==null ){
			this.endingElem = this.currentElement;			
			for(var i = 0; i < this.options.elemsSlide; i++ ){
				this.endingElem += direction;
				if( this.endingElem >= this.totalElements ) this.endingElem = 0;
				if( this.endingElem < 0 ) this.endingElem = this.totalElements-1;
			}
		}	
		
		if( this.direction == -1 ){
			this.rearange();
			$(this.options.thumbsContainer).setStyle('margin-left', -this.elementWidth);			
		}
		this.started = true;
		this.myFx.start({ 
			'margin-left': this.direction == 1 ? -this.elementWidth : 0 
		}).chain( function(){			
			this.rearange(true);			
			if(this.options.elemsSlide){
				if( this.endingElem !== this.currentElement ) {
					this.slide(this.direction);					
				}
				else this.endingElem=null;	
			}
			this.highlightNavs();
			this.options.elemsSlide = 1;	
		}.bind(this)  );		
	},
	
	rearange: function( rerun ){
		
		if(rerun) this.started = false;
		if( rerun && this.direction == -1 ) {
			return;
		}
		this.currentElement = this.currentIndex( this.direction );
				
		$(this.options.thumbsContainer).setStyle('margin-left',0);
		
		if( this.currentElement == 1 && this.direction == 1 ){
			this.elements[0].inject(this.elements[this.totalElements-1],'after');
			return;
		}
		if( (this.currentElement == 0 && this.direction ==1) || (this.direction==-1 && this.currentElement == this.totalElements-1) ){
			this.rearrangeElement( this.elements.getLast(), this.direction == 1 ? this.elements[this.totalElements-2] : this.elements[0]);
			return;
		}
		
		if( this.direction == 1 ){
			this.rearrangeElement( this.elements[this.currentElement-1], this.elements[this.currentElement-2]);
		}
		else{
			this.rearrangeElement( this.elements[this.currentElement], this.elements[this.currentElement+1]);
		}		
	},
	
	rearrangeElement: function( element , indicator ){
		this.direction == 1 ? element.inject(indicator,'after') : element.inject(indicator,'before');
	},
	
	currentIndex: function(){
		var elemIndex = null;
		switch( this.direction ){
			/* forward */
			case 1:
				elemIndex = this.currentElement >= this.totalElements-1 ? 0 : this.currentElement + this.direction;				
			break;
			/* backwards */
			case -1:
				elemIndex = this.currentElement == 0 ? this.totalElements - 1 : this.currentElement + this.direction;
			break;
		}
		return elemIndex;
	},
	
	startAutoSlide: function(){
		this.startIt = this.slide.bind(this).pass(this.direction||1);
		this.autoSlide = this.startIt.periodical(this.autoSlideTotal, this);
		this.elements.addEvents({
			'mouseover':function(){
				clearTimeout(this.autoSlide);						
			}.bind(this),
			'mouseout':function(){
				this.autoSlide = this.startIt.periodical(this.autoSlideTotal, this);
			}.bind(this)
		})
	},
	
	highlightNavs: function(){
		this.navs.removeClass('selected');
		this.navs[this.currentElement].addClass('selected');
	}
})